globals
trigger gg_trg_____________________________________001=null
trigger gg_trg_Main=null
trigger gg_trg_InitEventToStructs=null
trigger gg_trg_EnterEventToStruct=null
trigger gg_trg_DieEventRemovingStruct=null
trigger gg_trg_MISC=null
trigger gg_trg_Jump_Tick=null
trigger gg_trg_SimpleMoving=null
trigger gg_trg_fog_core=null
trigger gg_trg_Item_charges=null
trigger gg_trg_Jumps=null
trigger gg_trg_Facehugging=null
trigger gg_trg_EggHatch=null
trigger gg_trg_SkillInitializer=null
unit gg_unit_h000_0026=null
endglobals
function InitGlobals takes nothing returns nothing
endfunction
function CreateAllItems takes nothing returns nothing
local integer itemID
call CreateItem(0x41454747,5097.3,-3669.5)
call CreateItem(0x41454747,5157.9,-3762.6)
call CreateItem(0x41454747,5088.2,-3791.9)
call CreateItem(0x41454747,5176.7,-3881.1)
call CreateItem(0x41454747,5003.5,-3875.6)
call CreateItem(0x41454747,4807.6,-3732.1)
call CreateItem(0x41454747,4890.5,-3574.5)
call CreateItem(0x41454747,4933.9,-3790.2)
call CreateItem(0x41454747,4985.2,-3628.7)
call CreateItem(0x41454747,4896.6,-3674.5)
endfunction
function CreateUnitsForPlayer0 takes nothing returns nothing
local player p=Player(0)
local unit u
local integer unitID
local trigger t
local real life
set u=CreateUnit(p,0x61303030,5442.8,-3469.9,270.105)
set u=CreateUnit(p,0x61303031,5884.0,-3453.8,265.635)
set u=CreateUnit(p,0x61303032,5696.4,-3474.2,267.605)
set u=CreateUnit(p,0x61303033,5569.4,-3472.0,275.757)
set u=CreateUnit(p,0x41303132,6144.1,-3459.4,273.080)
call SetUnitState(u,UNIT_STATE_MANA,0)
set u=CreateUnit(p,0x61303035,5595.7,-4004.8,270.820)
call IssueImmediateOrder(u,"parasiteon")
set u=CreateUnit(p,0x61303037,5332.1,-3486.9,276.886)
set u=CreateUnit(p,0x61303036,5261.9,-3480.4,270.737)
set u=CreateUnit(p,0x61303133,5114.7,-3481.9,203.132)
set u=CreateUnit(p,0x6D303030,5391.3,-3572.9,278.182)
set u=CreateUnit(p,0x6D303031,5493.1,-3572.2,282.365)
set u=CreateUnit(p,0x6D303032,5586.9,-3575.7,275.297)
set u=CreateUnit(p,0x6D303036,5361.9,-3682.7,267.627)
set u=CreateUnit(p,0x68303030,5451.0,-3719.9,270.290)
call UnitAddItemToSlotById(u,0x49303030,0)
set u=CreateUnit(p,0x68706561,5717.0,-3836.3,272.663)
set u=CreateUnit(p,0x72303030,5535.8,-3733.6,274.675)
set u=CreateUnit(p,0x72303031,5644.7,-3732.5,263.578)
set u=CreateUnit(p,0x68303031,5486.3,-3874.7,188.230)
endfunction
function CreateNeutralHostile takes nothing returns nothing
local player p=Player(PLAYER_NEUTRAL_AGGRESSIVE)
local unit u
local integer unitID
local trigger t
local real life
set u=CreateUnit(p,0x6D303030,5746.6,-4814.5,353.262)
set u=CreateUnit(p,0x6D303030,5555.9,-5060.8,57.434)
set u=CreateUnit(p,0x6D303030,5262.7,-5041.9,208.786)
set u=CreateUnit(p,0x6D303030,5537.4,-4763.2,275.478)
set u=CreateUnit(p,0x6D303030,5394.0,-4873.3,114.876)
set u=CreateUnit(p,0x6D303030,5465.3,-5167.7,275.911)
set u=CreateUnit(p,0x6D303030,5835.8,-5001.9,159.737)
set u=CreateUnit(p,0x6D303030,5684.6,-5162.1,308.078)
endfunction
function CreatePlayerBuildings takes nothing returns nothing
endfunction
function CreatePlayerUnits takes nothing returns nothing
call CreateUnitsForPlayer0()
endfunction
function CreateAllUnits takes nothing returns nothing
call CreatePlayerBuildings()
call CreateNeutralHostile()
call CreatePlayerUnits()
endfunction
library Main
globals
hashtable Ud=InitHashtable()
hashtable hash=InitHashtable()
endglobals
globals
timer temp_timer
endglobals
struct Move
unit un
unit target
real x
real y
real time
real angle
real mod
real start_z
real end_z
real number=0
real start_number
real distance
endstruct
struct UnitData
unit Owner
real MortalStrikeSuccesChance=0.
real MortalStrikeFailChance=0.
boolean RemoveAfterDeath=true
real TimeBeforeRemove=5.
timer LifeCycleTimer=CreateTimer()
real HeightOfHead=72.
real UnitHeight=80.
real DeathTime=1.699
method remove takes nothing returns nothing
set this.Owner=null
call FlushChildHashtable(hash,GetHandleId(this.LifeCycleTimer))
call DestroyTimer(this.LifeCycleTimer)
set this.LifeCycleTimer=null
call this.destroy()
endmethod
endstruct
endlibrary
globals
group TempGroup=CreateGroup()
endglobals
function initz takes nothing returns boolean
local unit u=GetFilterUnit()
local UnitData ud
local integer UNIT_ID=GetUnitTypeId(u)
if            (UNIT_ID==0x6D303030 or UNIT_ID==0x6D303031 or UNIT_ID==0x6D303032 or UNIT_ID==0x4D303033 or UNIT_ID==0x4D303034 or UNIT_ID==0x4D303035 or UNIT_ID==0x6D303036)then
set ud=UnitData.create()
set ud.Owner=u
elseif(UNIT_ID==0x61303035 or UNIT_ID==0x61303036) then
set ud=UnitData.create()
set ud.Owner=u
endif
call SaveInteger(Ud,GetHandleId(u),0,ud)
set u=null
return         false
endfunction
function Trig_init_Actions takes nothing returns nothing
call GroupEnumUnitsInRect(TempGroup,bj_mapInitialPlayableArea,Filter(function initz))
endfunction
function InitTrig_InitEventToStructs takes nothing returns nothing
set gg_trg_InitEventToStructs=CreateTrigger()
call TriggerRegisterTimerEvent(gg_trg_InitEventToStructs,0.01,false)
call TriggerAddAction(gg_trg_InitEventToStructs,function Trig_init_Actions)
endfunction
function Trig_Enter_Actions takes nothing returns nothing
local unit u=GetTriggerUnit()
local UnitData ud
local integer UNIT_ID=GetUnitTypeId(u)
if            (UNIT_ID==0x6D303030 or UNIT_ID==0x6D303031 or UNIT_ID==0x6D303032 or UNIT_ID==0x4D303033 or UNIT_ID==0x4D303034 or UNIT_ID==0x4D303035 or UNIT_ID==0x6D303036)then
set ud=UnitData.create()
set ud.Owner=u
elseif(UNIT_ID==0x61303035) then
set ud=UnitData.create()
set ud.Owner=u
call IssueImmediateOrder(u,"parasiteon")
endif
call SaveInteger(Ud,GetHandleId(u),0,ud)
set u=null
endfunction
function InitTrig_EnterEventToStruct takes nothing returns nothing
set gg_trg_EnterEventToStruct=CreateTrigger()
call TriggerRegisterEnterRectSimple(gg_trg_EnterEventToStruct,bj_mapInitialPlayableArea)
call TriggerAddAction(gg_trg_EnterEventToStruct,function Trig_Enter_Actions)
endfunction
function Trig_Die_Actions takes nothing returns nothing
local unit actor=GetTriggerUnit()
local UnitData ud=LoadInteger(Ud,GetHandleId(actor),0)
if             ud.RemoveAfterDeath then
call TriggerSleepAction(ud.TimeBeforeRemove)
call ud.remove()
call FlushChildHashtable(Ud,GetHandleId(actor))
endif
set actor=null
endfunction
function InitTrig_DieEventRemovingStruct takes nothing returns nothing
set gg_trg_DieEventRemovingStruct=CreateTrigger()
call TriggerRegisterAnyUnitEventBJ(gg_trg_DieEventRemovingStruct,EVENT_PLAYER_UNIT_DEATH)
call TriggerAddAction(gg_trg_DieEventRemovingStruct,function Trig_Die_Actions)
endfunction
library MISC requires Main
globals
sound udg_SimError=null
endglobals
function DBU takes unit A,unit B returns real
local real dx=GetUnitX(B)-GetUnitX(A)
local real dy=GetUnitY(B)-GetUnitY(A)
return         SquareRoot((dx*dx)+(dy*dy))
endfunction
function ABU takes unit A,unit B returns real
return         Atan2(GetUnitY(B)-GetUnitY(A),GetUnitX(B)-GetUnitX(A))*bj_RADTODEG
endfunction
function ABUC takes unit A,real B_x,real B_y returns real
return         Atan2(B_y-GetUnitY(A),B_x-GetUnitX(A))*bj_RADTODEG
endfunction
function TBU takes unit A,unit B,real speed returns real
local real dx=GetUnitX(B)-GetUnitX(A)
local real dy=GetUnitY(B)-GetUnitY(A)
return        (SquareRoot((dx*dx)+(dy*dy))/speed)
endfunction
function ParabolaZ takes real h,real d,real x returns real
return        (4*h/d)*(d-x)*(x/d)
endfunction
function IsUnitBack takes unit uF,unit uWhichBack returns boolean
local real r1=bj_RADTODEG*Atan2(GetUnitY(uWhichBack)-GetUnitY(uF),GetUnitX(uWhichBack)-GetUnitX(uF))+360.
local real r2=GetUnitFacing(uWhichBack)+360.
if             GetUnitY(uWhichBack)<GetUnitY(uF)then
set r1=r1+360.
endif
return        (r1<=(r2+45.)and r1>=(r2-45.))
endfunction
function IsSide takes unit ataker,unit victim returns boolean
local real angle1=GetUnitFacing(victim)
local real angle2=ABU(ataker,victim)
if             not(GetUnitY(victim)>GetUnitY(ataker)) then
set angle1=angle1-(360.)
endif
if            (angle2<=(angle1+135.00)and angle2>=(angle1+45.00))or(angle2<=(angle1-45.00)and angle2>=(angle1-135.00))or(GetUnitY(victim)>GetUnitY(ataker)and GetUnitX(victim)>GetUnitX(ataker)and angle2<=(angle1-225.00)and angle2>=(angle1-315.00))or(GetUnitY(victim)<GetUnitY(ataker)and GetUnitX(victim)>GetUnitX(ataker)and angle2>=(angle1+225.00)and angle2<=(angle1+315.00)) then
return         true
endif
return         false
endfunction
function SimError takes player ForPlayer,string msg1 returns nothing
if             udg_SimError==null then
set udg_SimError=CreateSoundFromLabel("InterfaceError",false,false,false,10,10)
endif
if            (GetLocalPlayer()==ForPlayer)then
call ClearTextMessages()
call DisplayTimedTextToPlayer(ForPlayer,0.52,-1.00,2.00,"|cffffcc00"+msg1+"|r")
call StartSound(udg_SimError)
endif
endfunction
function TextUp takes string s,unit u,real size,real r,real g,real b returns nothing
local real x1=0.0355*Cos(90.*bj_DEGTORAD)
local real y1=0.0355*Sin(90.*bj_DEGTORAD)
set bj_lastCreatedTextTag=CreateTextTag()
call SetTextTagText(bj_lastCreatedTextTag,s,(size*0.023)/10)
call SetTextTagPosUnit(bj_lastCreatedTextTag,u,7)
call SetTextTagColor(bj_lastCreatedTextTag,PercentToInt(r,255),PercentToInt(g,255),PercentToInt(b,255),0)
call SetTextTagVelocity(bj_lastCreatedTextTag,x1,y1)
call SetTextTagPermanent(bj_lastCreatedTextTag,false)
call SetTextTagLifespan(bj_lastCreatedTextTag,2.5)
call SetTextTagFadepoint(bj_lastCreatedTextTag,0)
endfunction
function Text takes string s,unit u,unit u2,real size,real r,real g,real b returns nothing
local real x1=0.0355*Cos(ABU(u,u2)*bj_DEGTORAD)
local real y1=0.0355*Sin(ABU(u,u2)*bj_DEGTORAD)
set bj_lastCreatedTextTag=CreateTextTag()
call SetTextTagText(bj_lastCreatedTextTag,s,(size*0.023)/10)
call SetTextTagPosUnit(bj_lastCreatedTextTag,u2,7)
call SetTextTagColor(bj_lastCreatedTextTag,PercentToInt(r,255),PercentToInt(g,255),PercentToInt(b,255),0)
call SetTextTagVelocity(bj_lastCreatedTextTag,x1,y1)
call SetTextTagPermanent(bj_lastCreatedTextTag,false)
call SetTextTagLifespan(bj_lastCreatedTextTag,2.5)
call SetTextTagFadepoint(bj_lastCreatedTextTag,0)
endfunction
function AddSound takes string s,real x,real y returns nothing
local sound snd=CreateSound(s,false,true,true,10,10,"CombatSoundsEAX")
call SetSoundChannel(snd,40)
call SetSoundVolume(snd,127)
call SetSoundPitch(snd,1)
call SetSoundDistances(snd,600,10000)
call SetSoundDistanceCutoff(snd,2100)
call SetSoundConeAngles(snd,0.0,0.0,127)
call SetSoundConeOrientation(snd,0.0,0.0,0.0)
call SetSoundPosition(snd,x,y,50)
call StartSound(snd)
call KillSoundWhenDone(snd)
set snd=null
endfunction
function IsUnitHuman takes unit A returns boolean
local real UNIT_ID=GetUnitTypeId(A)
return        (UNIT_ID==0x6D303030 or UNIT_ID==0x6D303031 or UNIT_ID==0x6D303032 or UNIT_ID==0x4D303033 or UNIT_ID==0x4D303034 or UNIT_ID==0x4D303035 or UNIT_ID==0x6D303036)
endfunction
function IsUnitPreadator takes unit A returns boolean
local real UNIT_ID=GetUnitTypeId(A)
return        (UNIT_ID==0x72303030 or UNIT_ID==0x72303031)
endfunction
endlibrary
library TimeToFog initializer start
globals
private integer MAX_PLAYERS=2
public integer Season=1
private boolean IsWeather=true
private constant integer LIGHTNING_KEY=1512
private constant integer WEATHER_KEY=64
private constant real WIND_MIN_TIME=15
private constant real WIND_MAX_TIME=65
private constant real RAIN_MIN_TIME=15
private constant real RAIN_MAX_TIME=65
private constant real SUN_MIN_TIME=15
private constant real SUN_MAX_TIME=65
private constant real BLIZZARD_MIN_TIME=15
private constant real BLIZZARD_MAX_TIME=65
private constant real HEAVYSNOW_MIN_TIME=15
private constant real HEAVYSNOW_MAX_TIME=65
private constant real LIGHTSNOW_MIN_TIME=15
private constant real LIGHTSNOW_MAX_TIME=65
private constant integer FOG_MIN=0
private constant integer FOG_MAX=7000
private hashtable hash=InitHashtable()
private integer FogR=0
private integer FogG=49
private integer FogB=0
private boolean HaveWeather=false
private boolean sunny=false
private boolean rain=false
private boolean endWeather=false
private boolean array Hide[12]
private timer WeatherTimer=CreateTimer()
private weathereffect hj_WEATHER=null
endglobals
function PreloadSound3D_snd takes string s returns nothing
local sound snd=CreateSound(s,false,true,true,10,10,"CombatSoundsEAX")
call SetSoundChannel(snd,5)
call SetSoundVolume(snd,127)
call SetSoundPitch(snd,1)
call SetSoundDistances(snd,999999,99999)
call SetSoundDistanceCutoff(snd,99999)
call SetSoundConeAngles(snd,0.0,0.0,127)
call SetSoundConeOrientation(snd,0.0,0.0,0.0)
call SetSoundPosition(snd,0.0,0.0,50.0)
call StartSound(snd)
call StopSound(snd,false,false)
set snd=null
endfunction
function normal_sound takes string s,real x,real y returns nothing
local sound snd=CreateSound(s,false,true,true,10,10,"CombatSoundsEAX")
call SetSoundChannel(snd,40)
call SetSoundVolume(snd,127)
call SetSoundPitch(snd,1)
call SetSoundDistances(snd,600,10000)
call SetSoundDistanceCutoff(snd,2100)
call SetSoundConeAngles(snd,0.0,0.0,127)
call SetSoundConeOrientation(snd,0.0,0.0,0.0)
call SetSoundPosition(snd,x,y,50)
call StartSound(snd)
call KillSoundWhenDone(snd)
set snd=null
endfunction
private function LightningFilter takes real duration,blendmode bmode,string tex,integer red0,integer green0,integer blue0,integer trans0,integer red1,integer green1,integer blue1,integer trans1 returns nothing
local integer c=0
if             bj_cineFadeContinueTimer!=null then
call DestroyTimer(bj_cineFadeContinueTimer)
endif
if             bj_cineFadeFinishTimer!=null then
call DestroyTimer(bj_cineFadeFinishTimer)
endif
call SetCineFilterTexture(tex)
call SetCineFilterBlendMode(bmode)
call SetCineFilterTexMapFlags(TEXMAP_FLAG_NONE)
call SetCineFilterStartUV(0,0,1,1)
call SetCineFilterEndUV(0,0,1,1)
call SetCineFilterStartColor(red0,green0,blue0,trans0)
call SetCineFilterEndColor(red1,green1,blue1,trans1)
call SetCineFilterDuration(duration)
loop
if             Hide[c]then
if             GetLocalPlayer()==Player(c)then
call DisplayCineFilter(false)
endif
else
if             GetLocalPlayer()==Player(c)then
call DisplayCineFilter(true)
endif
endif
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
endfunction
private function ChangeFog takes nothing returns nothing
local timer t=GetExpiredTimer()
local integer h=GetHandleId(t)
local real time=LoadReal(hash,h,0)
local real period=LoadReal(hash,h,1)
local integer r=LoadInteger(hash,h,1)
local integer g=LoadInteger(hash,h,2)
local integer b=LoadInteger(hash,h,3)
local integer maxz=LoadInteger(hash,h,4)
local string s=LoadStr(hash,h,0)
local boolean booln=LoadBoolean(hash,h,0)
if             time<=0.then
call DestroyTimer(t)
if             s=="orange"then
set FogR=33
set FogG=49
set FogB=5
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX,100.,FogR*0.01,FogG*0.01,FogB*0.01)
elseif s=="white"then
set FogR=0
set FogG=49
set FogB=0
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX,100.,FogR*0.01,FogG*0.01,FogB*0.01)
elseif s=="blue"then
set FogR=25
set FogG=49
set FogB=31
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX-5000,100.,FogR*0.01,FogG*0.01,FogB*0.01)
elseif s=="black"then
set FogR=0
set FogG=10
set FogB=0
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX-5000,100.,FogR*0.01,FogG*0.01,FogB*0.01)
endif
call FlushChildHashtable(hash,h)
else
set FogR=FogR-r
set FogG=FogG-g
set FogB=FogB-b
if             s=="orange"and not booln then
if             FogR>=33 then
set FogR=33
endif
if             FogG>=49 then
set FogG=49
endif
if             FogB>=5 then
set FogB=5
endif
elseif s=="white"then
if             FogR>=0 then
set FogR=0
endif
if             FogG>=49 then
set FogG=49
endif
if             FogB>=0 then
set FogB=0
endif
elseif s=="blue"then
if             FogR>=25 then
set FogR=25
endif
if             FogG<=49 then
set FogG=49
endif
if             FogB<=31 then
set FogB=31
endif
elseif s=="black"then
if             FogR<=0 then
set FogR=0
endif
if             FogG<=10 then
set FogG=10
endif
if             FogB<=0 then
set FogB=0
endif
endif
call SaveReal(hash,h,0,time-period)
if             s=="black"then
if             maxz<5000 then
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX-maxz,100.,FogR*0.01,FogG*0.01,FogB*0.01)
call SaveInteger(hash,h,4,maxz+550)
else
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX-5000,100.,FogR*0.01,FogG*0.01,FogB*0.01)
endif
elseif s=="orange"then
if             maxz>0 then
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX-maxz,100.,FogR*0.01,FogG*0.01,FogB*0.01)
call SaveInteger(hash,h,4,maxz-550)
else
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX,100.,FogR*0.01,FogG*0.01,FogB*0.01)
endif
elseif s=="blue"then
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX-5000,100.,FogR*0.01,FogG*0.01,FogB*0.01)
elseif s!="black"and s!="orange"and s!="blue"then
call SetTerrainFogEx(0,FOG_MIN,FOG_MAX,100.,FogR*0.01,FogG*0.01,FogB*0.01)
endif
endif
set t=null
endfunction
public function CheckEnter takes player p returns nothing
set Hide[GetPlayerId(p)]=true
if             GetLocalPlayer()==p then
call EnableWeatherEffect(hj_WEATHER,false)
endif
endfunction
public function CheckHide takes player p returns nothing
set Hide[GetPlayerId(p)]=false
if             GetLocalPlayer()==p then
call EnableWeatherEffect(hj_WEATHER,true)
endif
endfunction
function WeatherTime takes nothing returns nothing
local timer t=GetExpiredTimer()
local integer h=GetHandleId(t)
local real time=LoadReal(hash,h,0)
local integer r
if            (time<=0.or endWeather)then
call DestroyTimer(t)
call EnableWeatherEffect(hj_WEATHER,false)
call RemoveWeatherEffect(hj_WEATHER)
call FlushChildHashtable(hash,h)
set endWeather=false
set HaveWeather=false
set rain=false
set sunny=false
else
if             rain then
set r=GetRandomInt(1,LIGHTNING_KEY)
if             r==1 then
call LightningFilter(1,BLEND_MODE_BLEND,"ReplaceableTextures\\CameraMasks\\White_mask.blp",255,255,255,255,255,255,255,0)
call normal_sound("Thunder Low.wav",GetRandomReal(GetRectMinX(bj_mapInitialPlayableArea),GetRectMaxX(bj_mapInitialPlayableArea)),GetRandomReal(GetRectMinY(bj_mapInitialPlayableArea),GetRectMaxY(bj_mapInitialPlayableArea)))
elseif r==2 then
call LightningFilter(1,BLEND_MODE_BLEND,"ReplaceableTextures\\CameraMasks\\White_mask.blp",255,255,255,255,255,255,255,0)
call normal_sound("Thunder Normal.wav",GetRandomReal(GetRectMinX(bj_mapInitialPlayableArea),GetRectMaxX(bj_mapInitialPlayableArea)),GetRandomReal(GetRectMinY(bj_mapInitialPlayableArea),GetRectMaxY(bj_mapInitialPlayableArea)))
elseif r==3 then
call LightningFilter(1,BLEND_MODE_BLEND,"ReplaceableTextures\\CameraMasks\\White_mask.blp",255,255,255,255,255,255,255,0)
call normal_sound("Thunder Hight.wav",GetRandomReal(GetRectMinX(bj_mapInitialPlayableArea),GetRectMaxX(bj_mapInitialPlayableArea)),GetRandomReal(GetRectMinY(bj_mapInitialPlayableArea),GetRectMaxY(bj_mapInitialPlayableArea)))
endif
endif
call SaveReal(hash,h,0,time-0.02)
endif
set t=null
endfunction
private function Weather takes nothing returns nothing
local real dt=GetFloatGameState(GAME_STATE_TIME_OF_DAY)
local integer rnd=GetRandomInt(1,WEATHER_KEY)
local timer t
local integer c=0
if             not HaveWeather then
if             dt>=10.and dt<30.and rnd==1 then
set HaveWeather=true
set sunny=true
call RemoveWeatherEffect(hj_WEATHER)
set hj_WEATHER=AddWeatherEffect(bj_mapInitialPlayableArea,0x4C526161)
loop
if             not Hide[c]then
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,true)
endif
else
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,false)
endif
endif
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
set t=CreateTimer()
call TimerStart(t,0.02,true,function WeatherTime)
call SaveReal(hash,GetHandleId(t),0,GetRandomReal(SUN_MIN_TIME,SUN_MAX_TIME))
elseif rnd==2 and Season==1 then
set HaveWeather=true
call RemoveWeatherEffect(hj_WEATHER)
set hj_WEATHER=AddWeatherEffect(bj_mapInitialPlayableArea,0x574F6C77)
loop
if             not Hide[c]then
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,true)
endif
else
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,false)
endif
endif
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
set t=CreateTimer()
call TimerStart(t,0.02,true,function WeatherTime)
call SaveReal(hash,GetHandleId(t),0,GetRandomReal(WIND_MIN_TIME,WIND_MAX_TIME))
elseif rnd==2 and Season==2 then
set HaveWeather=true
call RemoveWeatherEffect(hj_WEATHER)
set hj_WEATHER=AddWeatherEffect(bj_mapInitialPlayableArea,0x534E6273)
loop
if             not Hide[c]then
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,true)
endif
else
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,false)
endif
endif
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
set t=CreateTimer()
call TimerStart(t,0.02,true,function WeatherTime)
call SaveReal(hash,GetHandleId(t),0,GetRandomReal(BLIZZARD_MIN_TIME,BLIZZARD_MAX_TIME))
elseif rnd==3 and Season==1 then
set HaveWeather=true
set rain=true
call RemoveWeatherEffect(hj_WEATHER)
set hj_WEATHER=AddWeatherEffect(bj_mapInitialPlayableArea,0x524C6872)
loop
if             not Hide[c]then
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,true)
endif
else
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,false)
endif
endif
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
set t=CreateTimer()
call TimerStart(t,0.02,true,function WeatherTime)
call SaveReal(hash,GetHandleId(t),0,GetRandomReal(RAIN_MIN_TIME,RAIN_MAX_TIME))
elseif rnd==3 and Season==2 then
set HaveWeather=true
call RemoveWeatherEffect(hj_WEATHER)
set hj_WEATHER=AddWeatherEffect(bj_mapInitialPlayableArea,0x534E6873)
loop
if             not Hide[c]then
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,true)
endif
else
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,false)
endif
endif
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
set t=CreateTimer()
call TimerStart(t,0.02,true,function WeatherTime)
call SaveReal(hash,GetHandleId(t),0,GetRandomReal(HEAVYSNOW_MIN_TIME,HEAVYSNOW_MAX_TIME))
elseif rnd==4 and Season==2 then
set HaveWeather=true
call RemoveWeatherEffect(hj_WEATHER)
set hj_WEATHER=AddWeatherEffect(bj_mapInitialPlayableArea,0x534E6C73)
loop
if             not Hide[c]then
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,true)
endif
else
if             GetLocalPlayer()==Player(c)then
call EnableWeatherEffect(hj_WEATHER,false)
endif
endif
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
set t=CreateTimer()
call TimerStart(t,0.02,true,function WeatherTime)
call SaveReal(hash,GetHandleId(t),0,GetRandomReal(LIGHTSNOW_MIN_TIME,LIGHTSNOW_MAX_TIME))
endif
endif
set t=null
endfunction
private function Trig_fog_core_Actions takes nothing returns nothing
local timer t
local integer h
local real dt=GetFloatGameState(GAME_STATE_TIME_OF_DAY)
if            (dt>18.and dt<6.and sunny)then
set endWeather=true
endif
if             dt==18.00 then
set t=CreateTimer()
set h=GetHandleId(t)
call TimerStart(t,16.,true,function ChangeFog)
call SaveReal(hash,h,0,176.)
call SaveReal(hash,h,1,16.)
call SaveBoolean(hash,h,0,true)
call SaveInteger(hash,h,1,9)
call SaveInteger(hash,h,2,6)
call SaveInteger(hash,h,3,3)
call SaveInteger(hash,h,4,0)
call SaveStr(hash,h,0,"black")
elseif dt==24.00 then
set t=CreateTimer()
set h=GetHandleId(t)
call TimerStart(t,8.,true,function ChangeFog)
call SaveReal(hash,h,0,56.)
call SaveReal(hash,h,1,8.)
call SaveBoolean(hash,h,0,true)
call SaveInteger(hash,h,1,-1)
call SaveInteger(hash,h,2,-1)
call SaveInteger(hash,h,3,-2)
call SaveStr(hash,h,0,"blue")
elseif dt==02.00 then
set t=CreateTimer()
set h=GetHandleId(t)
call TimerStart(t,16.,true,function ChangeFog)
call SaveReal(hash,h,0,176.)
call SaveReal(hash,h,1,16.)
call SaveBoolean(hash,h,0,true)
call SaveInteger(hash,h,1,-3)
call SaveInteger(hash,h,2,-1)
call SaveInteger(hash,h,3,3)
call SaveInteger(hash,h,4,5000)
call SaveStr(hash,h,0,"orange")
elseif dt==06.00 then
set t=CreateTimer()
set h=GetHandleId(t)
call TimerStart(t,16.,true,function ChangeFog)
call SaveReal(hash,h,0,176.)
call SaveReal(hash,h,1,16.)
call SaveBoolean(hash,h,0,false)
call SaveInteger(hash,h,1,2)
call SaveInteger(hash,h,2,-2)
call SaveInteger(hash,h,3,4)
call SaveStr(hash,h,0,"white")
elseif dt==12.00 then
set t=CreateTimer()
set h=GetHandleId(t)
call TimerStart(t,16.,true,function ChangeFog)
call SaveReal(hash,h,0,176.)
call SaveReal(hash,h,1,16.)
call SaveBoolean(hash,h,0,false)
call SaveInteger(hash,h,1,-3)
call SaveInteger(hash,h,2,0)
call SaveInteger(hash,h,3,-1)
call SaveStr(hash,h,0,"orange")
call DisplayTextToForce(bj_FORCE_ALL_PLAYERS,"123")
endif
set t=null
endfunction
function InitTrig_fog_core takes nothing returns nothing
set gg_trg_fog_core=CreateTrigger()
if             IsWeather then
call TimerStart(WeatherTimer,1.01,true,function Weather)
endif
call TriggerAddAction(gg_trg_fog_core,function Trig_fog_core_Actions)
endfunction
private function start takes nothing returns nothing
local integer c=0
loop
set Hide[c]=false
set c=c+1
exitwhen       c==MAX_PLAYERS
endloop
endfunction
endlibrary
function Trig_Item_charges_Conditions takes nothing returns boolean
if            (not(UnitHasItemOfTypeBJ(GetManipulatingUnit(),GetItemTypeId(GetManipulatedItem()))==true))then
return         false
endif
if            (not(GetManipulatedItem()!=GetItemOfTypeFromUnitBJ(GetManipulatingUnit(),GetItemTypeId(GetManipulatedItem()))))then
return         false
endif
if            (not(GetItemType(GetManipulatedItem())==ITEM_TYPE_CHARGED))then
return         false
endif
return         true
endfunction
function Trig_Item_charges_Actions takes nothing returns nothing
call SetItemCharges(GetItemOfTypeFromUnitBJ(GetManipulatingUnit(),GetItemTypeId(GetManipulatedItem())),(GetItemCharges(GetItemOfTypeFromUnitBJ(GetManipulatingUnit(),GetItemTypeId(GetManipulatedItem())))+GetItemCharges(GetManipulatedItem())))
call RemoveItem(GetManipulatedItem())
endfunction
function InitTrig_Item_charges takes nothing returns nothing
set gg_trg_Item_charges=CreateTrigger()
call TriggerRegisterAnyUnitEventBJ(gg_trg_Item_charges,EVENT_PLAYER_UNIT_PICKUP_ITEM)
call TriggerAddCondition(gg_trg_Item_charges,Condition(function Trig_Item_charges_Conditions))
call TriggerAddAction(gg_trg_Item_charges,function Trig_Item_charges_Actions)
endfunction
library Jumps needs MISC
function StartJump takes unit caster,real range,real x,real y returns nothing
endfunction
endlibrary
library Facehugging needs MISC
function SnipeAnimBug takes nothing returns nothing
local timer t=GetExpiredTimer()
local unit victim=LoadUnitHandle(hash,GetHandleId(t),0)
if            (GetUnitState(victim,UNIT_STATE_LIFE)<=0.045) then
call FlushChildHashtable(hash,GetHandleId(t))
call DestroyTimer(t)
else
call SetUnitAnimation(victim,"decay flesh")
endif
set victim=null
set t=null
endfunction
function StuckDeathAnim takes nothing returns nothing
local timer t=GetExpiredTimer()
local unit victim=LoadUnitHandle(hash,GetHandleId(t),0)
call SetUnitAnimation(victim,"decay flesh")
call TimerStart(t,0.5,true,function SnipeAnimBug)
set victim=null
endfunction
function HumanGrowing takes nothing returns nothing
local UnitData ud=LoadInteger(Ud,GetHandleId(LoadUnitHandle(hash,GetHandleId(GetExpiredTimer()),0)),0)
set bj_lastCreatedUnit=CreateUnit(Player(0),0x61303030,GetUnitX(ud.Owner),GetUnitY(ud.Owner),GetRandomReal(0.,360.))
call ShowUnit(ud.Owner,false)
call KillUnit(ud.Owner)
endfunction
function PredatorGrowing takes nothing returns nothing
local UnitData ud=LoadInteger(Ud,GetHandleId(LoadUnitHandle(hash,GetHandleId(GetExpiredTimer()),0)),0)
set bj_lastCreatedUnit=CreateUnit(Player(0),0x61303032,GetUnitX(ud.Owner),GetUnitY(ud.Owner),GetRandomReal(0.,360.))
call ShowUnit(ud.Owner,false)
call KillUnit(ud.Owner)
endfunction
function HumanIncubationDone takes nothing returns nothing
local UnitData ud=LoadInteger(Ud,GetHandleId(LoadUnitHandle(hash,GetHandleId(GetExpiredTimer()),0)),0)
call DestroyEffect(AddSpecialEffect("Objects\\Spawnmodels\\Human\\HumanLargeDeathExplode\\HumanLargeDeathExplode.mdl",GetUnitX(ud.Owner),GetUnitY(ud.Owner)))
call AddSound("chestburstOpt.wav",GetUnitX(ud.Owner),GetUnitY(ud.Owner))
call SetUnitTimeScale(ud.Owner,0.)
call KillUnit(ud.Owner)
set bj_lastCreatedUnit=CreateUnit(Player(0),0x61303036,GetUnitX(ud.Owner),GetUnitY(ud.Owner),GetRandomReal(0.,360.))
set ud=UnitData.create()
call SaveInteger(Ud,GetHandleId(bj_lastCreatedUnit),0,ud)
set ud.Owner=bj_lastCreatedUnit
call SaveUnitHandle(hash,GetHandleId(ud.LifeCycleTimer),0,bj_lastCreatedUnit)
call TimerStart(ud.LifeCycleTimer,22.,false,function HumanGrowing)
call UnitApplyTimedLife(bj_lastCreatedUnit,0x42544C46,22.+0.1)
endfunction
function PredatorIncubationDone takes nothing returns nothing
local UnitData ud=LoadInteger(Ud,GetHandleId(LoadUnitHandle(hash,GetHandleId(GetExpiredTimer()),0)),0)
call DestroyEffect(AddSpecialEffect("Objects\\Spawnmodels\\Human\\HumanLargeDeathExplode\\HumanLargeDeathExplode.mdl",GetUnitX(ud.Owner),GetUnitY(ud.Owner)))
call AddSound("chestburstOpt.wav",GetUnitX(ud.Owner),GetUnitY(ud.Owner))
call KillUnit(ud.Owner)
set bj_lastCreatedUnit=CreateUnit(Player(0),0x61303037,GetUnitX(ud.Owner),GetUnitY(ud.Owner),GetRandomReal(0.,360.))
set ud=UnitData.create()
call SaveInteger(Ud,GetHandleId(bj_lastCreatedUnit),0,ud)
set ud.Owner=bj_lastCreatedUnit
call SaveUnitHandle(hash,GetHandleId(ud.LifeCycleTimer),0,bj_lastCreatedUnit)
call TimerStart(ud.LifeCycleTimer,27.,false,function PredatorGrowing)
call UnitApplyTimedLife(bj_lastCreatedUnit,0x42544C46,27.+0.1)
endfunction
function PounceTick takes nothing returns nothing
local timer t=GetExpiredTimer()
local timer t2
local Move DB=R2I(TimerGetRemaining(t))
local UnitData ud
local UnitData ud2
local real r=ParabolaZ(120.,DB.distance,DB.number)
call SetUnitFlyHeight(DB.un,r,0.)
if            (DB.time<=0.or r<0.)then
call SetUnitFlyHeight(DB.un,0.,0.)
call PauseUnit(DB.un,false)
call SetUnitPathing(DB.un,true)
set ud2=LoadInteger(Ud,GetHandleId(DB.target),0)
set ud=LoadInteger(Ud,GetHandleId(DB.un),0)
if            (GetRandomReal(0.01,100.)<=50.+(ud.MortalStrikeSuccesChance-ud2.MortalStrikeFailChance)and not IsUnitPaused(DB.target)) then
call ShowUnit(DB.un,false)
call KillUnit(DB.un)
call IssueImmediateOrder(DB.target,"stop")
call IssueImmediateOrder(DB.target,"holdposition")
call SetUnitAnimation(DB.target,"death")
call SetUnitOwner(DB.target,Player(PLAYER_NEUTRAL_PASSIVE),false)
set temp_timer=CreateTimer()
call SaveUnitHandle(hash,GetHandleId(temp_timer),0,DB.target)
call SaveUnitHandle(hash,GetHandleId(ud2.LifeCycleTimer),0,DB.target)
call TimerStart(temp_timer,ud2.DeathTime,false,function StuckDeathAnim)
if             IsUnitHuman(DB.target) then
call TimerStart(ud2.LifeCycleTimer,25.,false,function HumanIncubationDone)
else
call TimerStart(ud2.LifeCycleTimer,35.,false,function PredatorIncubationDone)
endif
endif
call DB.destroy()
call FlushChildHashtable(Ud,GetHandleId(t))
call DestroyTimer(t)
elseif GetUnitState(DB.un,UNIT_STATE_LIFE)<=0.045 then
call SetUnitFlyHeight(DB.un,0.,0.)
call PauseUnit(DB.un,false)
call SetUnitPathing(DB.un,true)
call DB.destroy()
call FlushChildHashtable(Ud,GetHandleId(t))
call DestroyTimer(t)
else
set DB.number=DB.number+1
set DB.time=DB.time-(0.02)
call SetUnitPosition(DB.un,GetUnitX(DB.un)+DB.x,GetUnitY(DB.un)+DB.y)
call TimerStart(t,0.02,false,function PounceTick)
endif
set t=null
endfunction
function Facehugging_Init takes unit caster,unit target returns nothing
local timer t=CreateTimer()
local real ang=ABU(caster,target)
local real step
local Move DB=Move.create()
local UnitData ud=LoadInteger(Ud,GetHandleId(target),0)
call SetUnitPosition(caster,GetUnitX(caster),GetUnitY(caster))
call IssueImmediateOrder(caster,"stop")
set DB.un=caster
set DB.target=target
set DB.angle=ang
set DB.time=TBU(caster,target,1200.)-0.14
set DB.distance=DBU(caster,target)/20.
set step=DBU(caster,target)/(DB.time/0.02)
set DB.x=(step*Cos(ang*bj_DEGTORAD))
set DB.y=(step*Sin(ang*bj_DEGTORAD))
call UnitAddAbility(caster,0x41726176)
call UnitRemoveAbility(caster,0x41726176)
set DB.end_z=ud.HeightOfHead
call SetUnitPathing(caster,false)
call PauseUnit(caster,true)
call TimerStart(t,I2R(DB),false,null)
call PauseTimer(t)
call TimerStart(t,0.02,false,function PounceTick)
call AddSound("facehugpounceOpt.wav",GetUnitX(caster),GetUnitY(caster))
set t=null
endfunction
endlibrary
function Trig_EggHatch_Actions takes unit caster returns nothing
if             GetRandomReal(0.01,100.)<=45. then
call KillUnit(caster)
call CreateUnit(GetOwningPlayer(caster),0x61303035,GetUnitX(caster),GetUnitY(caster),GetRandomReal(0.,360.))
endif
endfunction
function Trig_EggHatch_Conds takes nothing returns boolean
if             GetUnitTypeId(GetAttacker())==0x61303133 then
call Trig_EggHatch_Actions(GetAttacker())
endif
return         false
endfunction
function InitTrig_EggHatch takes nothing returns nothing
set gg_trg_EggHatch=CreateTrigger()
call TriggerRegisterAnyUnitEventBJ(gg_trg_EggHatch,EVENT_PLAYER_UNIT_ATTACKED)
call TriggerAddCondition(gg_trg_EggHatch,Condition(function Trig_EggHatch_Conds))
endfunction
function Trig_SkillInitializer_Actions takes nothing returns nothing
local integer id=GetSpellAbilityId()
if             id==0x41303031 then
call Facehugging_Init(GetSpellAbilityUnit(),GetSpellTargetUnit())
elseif id==0x41303030 then
call CreateUnit(GetOwningPlayer(GetSpellAbilityUnit()),0x61303133,GetSpellTargetX(),GetSpellTargetY(),GetRandomReal(0.,360.))
elseif id==0x41303033 then
call Facehugging_Init(GetSpellAbilityUnit(),GetSpellTargetUnit())
endif
endfunction
function InitTrig_SkillInitializer takes nothing returns nothing
set gg_trg_SkillInitializer=CreateTrigger()
call TriggerRegisterAnyUnitEventBJ(gg_trg_SkillInitializer,EVENT_PLAYER_UNIT_SPELL_EFFECT)
call TriggerAddAction(gg_trg_SkillInitializer,function Trig_SkillInitializer_Actions)
endfunction
function InitCustomTriggers takes nothing returns nothing
call InitTrig_Main()
call InitTrig_InitEventToStructs()
call InitTrig_EnterEventToStruct()
call InitTrig_DieEventRemovingStruct()
call InitTrig_MISC()
call InitTrig_fog_core()
call InitTrig_Item_charges()
call InitTrig_Jumps()
call InitTrig_Facehugging()
call InitTrig_EggHatch()
call InitTrig_SkillInitializer()
endfunction
function InitCustomPlayerSlots takes nothing returns nothing
call SetPlayerStartLocation(Player(0),0)
call ForcePlayerStartLocation(Player(0),0)
call SetPlayerColor(Player(0),ConvertPlayerColor(0))
call SetPlayerRacePreference(Player(0),RACE_PREF_HUMAN)
call SetPlayerRaceSelectable(Player(0),false)
call SetPlayerController(Player(0),MAP_CONTROL_USER)
call SetPlayerStartLocation(Player(1),1)
call ForcePlayerStartLocation(Player(1),1)
call SetPlayerColor(Player(1),ConvertPlayerColor(1))
call SetPlayerRacePreference(Player(1),RACE_PREF_HUMAN)
call SetPlayerRaceSelectable(Player(1),false)
call SetPlayerController(Player(1),MAP_CONTROL_USER)
call SetPlayerStartLocation(Player(2),2)
call ForcePlayerStartLocation(Player(2),2)
call SetPlayerColor(Player(2),ConvertPlayerColor(2))
call SetPlayerRacePreference(Player(2),RACE_PREF_UNDEAD)
call SetPlayerRaceSelectable(Player(2),false)
call SetPlayerController(Player(2),MAP_CONTROL_USER)
call SetPlayerStartLocation(Player(3),3)
call ForcePlayerStartLocation(Player(3),3)
call SetPlayerColor(Player(3),ConvertPlayerColor(3))
call SetPlayerRacePreference(Player(3),RACE_PREF_UNDEAD)
call SetPlayerRaceSelectable(Player(3),false)
call SetPlayerController(Player(3),MAP_CONTROL_USER)
call SetPlayerStartLocation(Player(4),4)
call ForcePlayerStartLocation(Player(4),4)
call SetPlayerColor(Player(4),ConvertPlayerColor(4))
call SetPlayerRacePreference(Player(4),RACE_PREF_NIGHTELF)
call SetPlayerRaceSelectable(Player(4),false)
call SetPlayerController(Player(4),MAP_CONTROL_USER)
call SetPlayerStartLocation(Player(5),5)
call ForcePlayerStartLocation(Player(5),5)
call SetPlayerColor(Player(5),ConvertPlayerColor(5))
call SetPlayerRacePreference(Player(5),RACE_PREF_NIGHTELF)
call SetPlayerRaceSelectable(Player(5),false)
call SetPlayerController(Player(5),MAP_CONTROL_USER)
call SetPlayerStartLocation(Player(6),6)
call ForcePlayerStartLocation(Player(6),6)
call SetPlayerColor(Player(6),ConvertPlayerColor(6))
call SetPlayerRacePreference(Player(6),RACE_PREF_NIGHTELF)
call SetPlayerRaceSelectable(Player(6),false)
call SetPlayerController(Player(6),MAP_CONTROL_COMPUTER)
call SetPlayerStartLocation(Player(7),7)
call ForcePlayerStartLocation(Player(7),7)
call SetPlayerColor(Player(7),ConvertPlayerColor(7))
call SetPlayerRacePreference(Player(7),RACE_PREF_HUMAN)
call SetPlayerRaceSelectable(Player(7),false)
call SetPlayerController(Player(7),MAP_CONTROL_COMPUTER)
call SetPlayerStartLocation(Player(8),8)
call ForcePlayerStartLocation(Player(8),8)
call SetPlayerColor(Player(8),ConvertPlayerColor(8))
call SetPlayerRacePreference(Player(8),RACE_PREF_UNDEAD)
call SetPlayerRaceSelectable(Player(8),false)
call SetPlayerController(Player(8),MAP_CONTROL_COMPUTER)
endfunction
function InitCustomTeams takes nothing returns nothing
call SetPlayerTeam(Player(0),0)
call SetPlayerState(Player(0),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerTeam(Player(1),0)
call SetPlayerState(Player(1),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerTeam(Player(7),0)
call SetPlayerState(Player(7),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerAllianceStateAllyBJ(Player(0),Player(1),true)
call SetPlayerAllianceStateAllyBJ(Player(0),Player(7),true)
call SetPlayerAllianceStateAllyBJ(Player(1),Player(0),true)
call SetPlayerAllianceStateAllyBJ(Player(1),Player(7),true)
call SetPlayerAllianceStateAllyBJ(Player(7),Player(0),true)
call SetPlayerAllianceStateAllyBJ(Player(7),Player(1),true)
call SetPlayerAllianceStateVisionBJ(Player(0),Player(1),true)
call SetPlayerAllianceStateVisionBJ(Player(0),Player(7),true)
call SetPlayerAllianceStateVisionBJ(Player(1),Player(0),true)
call SetPlayerAllianceStateVisionBJ(Player(1),Player(7),true)
call SetPlayerAllianceStateVisionBJ(Player(7),Player(0),true)
call SetPlayerAllianceStateVisionBJ(Player(7),Player(1),true)
call SetPlayerTeam(Player(2),1)
call SetPlayerState(Player(2),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerTeam(Player(3),1)
call SetPlayerState(Player(3),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerTeam(Player(8),1)
call SetPlayerState(Player(8),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerAllianceStateAllyBJ(Player(2),Player(3),true)
call SetPlayerAllianceStateAllyBJ(Player(2),Player(8),true)
call SetPlayerAllianceStateAllyBJ(Player(3),Player(2),true)
call SetPlayerAllianceStateAllyBJ(Player(3),Player(8),true)
call SetPlayerAllianceStateAllyBJ(Player(8),Player(2),true)
call SetPlayerAllianceStateAllyBJ(Player(8),Player(3),true)
call SetPlayerAllianceStateVisionBJ(Player(2),Player(3),true)
call SetPlayerAllianceStateVisionBJ(Player(2),Player(8),true)
call SetPlayerAllianceStateVisionBJ(Player(3),Player(2),true)
call SetPlayerAllianceStateVisionBJ(Player(3),Player(8),true)
call SetPlayerAllianceStateVisionBJ(Player(8),Player(2),true)
call SetPlayerAllianceStateVisionBJ(Player(8),Player(3),true)
call SetPlayerTeam(Player(4),2)
call SetPlayerState(Player(4),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerTeam(Player(5),2)
call SetPlayerState(Player(5),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerTeam(Player(6),2)
call SetPlayerState(Player(6),PLAYER_STATE_ALLIED_VICTORY,1)
call SetPlayerAllianceStateAllyBJ(Player(4),Player(5),true)
call SetPlayerAllianceStateAllyBJ(Player(4),Player(6),true)
call SetPlayerAllianceStateAllyBJ(Player(5),Player(4),true)
call SetPlayerAllianceStateAllyBJ(Player(5),Player(6),true)
call SetPlayerAllianceStateAllyBJ(Player(6),Player(4),true)
call SetPlayerAllianceStateAllyBJ(Player(6),Player(5),true)
call SetPlayerAllianceStateVisionBJ(Player(4),Player(5),true)
call SetPlayerAllianceStateVisionBJ(Player(4),Player(6),true)
call SetPlayerAllianceStateVisionBJ(Player(5),Player(4),true)
call SetPlayerAllianceStateVisionBJ(Player(5),Player(6),true)
call SetPlayerAllianceStateVisionBJ(Player(6),Player(4),true)
call SetPlayerAllianceStateVisionBJ(Player(6),Player(5),true)
endfunction
function InitAllyPriorities takes nothing returns nothing
call SetStartLocPrioCount(0,1)
call SetStartLocPrio(0,0,1,MAP_LOC_PRIO_HIGH)
call SetStartLocPrioCount(1,1)
call SetStartLocPrio(1,0,0,MAP_LOC_PRIO_HIGH)
call SetStartLocPrioCount(2,1)
call SetStartLocPrio(2,0,3,MAP_LOC_PRIO_HIGH)
call SetStartLocPrioCount(3,1)
call SetStartLocPrio(3,0,2,MAP_LOC_PRIO_HIGH)
call SetStartLocPrioCount(4,1)
call SetStartLocPrio(4,0,5,MAP_LOC_PRIO_HIGH)
call SetStartLocPrioCount(5,1)
call SetStartLocPrio(5,0,4,MAP_LOC_PRIO_HIGH)
endfunction
function main takes nothing returns nothing
call SetCameraBounds(-7424.0+GetCameraMargin(CAMERA_MARGIN_LEFT),-5632.0+GetCameraMargin(CAMERA_MARGIN_BOTTOM),7424.0-GetCameraMargin(CAMERA_MARGIN_RIGHT),5120.0-GetCameraMargin(CAMERA_MARGIN_TOP),-7424.0+GetCameraMargin(CAMERA_MARGIN_LEFT),5120.0-GetCameraMargin(CAMERA_MARGIN_TOP),7424.0-GetCameraMargin(CAMERA_MARGIN_RIGHT),-5632.0+GetCameraMargin(CAMERA_MARGIN_BOTTOM))
call SetDayNightModels("Environment\\DNC\\DNCFelwood\\DNCFelwoodTerrain\\DNCFelwoodTerrain.mdl","Environment\\DNC\\DNCFelwood\\DNCFelwoodUnit\\DNCFelwoodUnit.mdl")
call NewSoundEnvironment("Default")
call SetAmbientDaySound("FelwoodDay")
call SetAmbientNightSound("FelwoodNight")
call SetMapMusic("Music",true,0)
call CreateAllItems()
call CreateAllUnits()
call InitBlizzard()
call InitGlobals()
call InitCustomTriggers()
endfunction
function config takes nothing returns nothing
call SetMapName("TRIGSTR_001")
call SetMapDescription("TRIGSTR_003")
call SetPlayers(9)
call SetTeams(9)
call SetGamePlacement(MAP_PLACEMENT_TEAMS_TOGETHER)
call DefineStartLocation(0,-6336.0,-1728.0)
call DefineStartLocation(1,-6272.0,-2368.0)
call DefineStartLocation(2,6336.0,-2112.0)
call DefineStartLocation(3,6080.0,-2688.0)
call DefineStartLocation(4,512.0,4160.0)
call DefineStartLocation(5,-128.0,4288.0)
call DefineStartLocation(6,576.0,3584.0)
call DefineStartLocation(7,-5760.0,-1920.0)
call DefineStartLocation(8,5824.0,-2176.0)
call InitCustomPlayerSlots()
call InitCustomTeams()
call InitAllyPriorities()
endfunction