	flyMenu = wehack.addmenu("Fly")
	flyMenuEnabled = TogMenuEntry:New(flyMenu,"Enable Fly Data Processor",nil,true)
	wehack.addmenuseparator(flyMenu)
	flyMenuLog = TogMenuEntry:New(flyMenu,"Enable preprocessor log",nil,true)
	flyMenuExtLog = TogMenuEntry:New(flyMenu,"Enable cleanup log",nil,false)
	wehack.addmenuseparator(flyMenu)
	flyMenuUseJava = TogMenuEntry:New(flyMenu,"Use .jar version",nil,false)

function fly_export_scexp(ext,mappath)
	local filepath0 = scexpSFMPQSTR.." -e \""..mappath.."\" \"war3map."
	local filepath1 = "\" \"fly\\data\\war3map."
	local filepath2 = "\""
	local cmd = filepath0..ext..filepath1..ext..filepath2
	wehack.runprocess2(cmd)
end

function fly_import_scexp(ext,mappath)
	local filepath0 = scexpSFMPQSTR.." -i \""..mappath.."\" \"fly\\data\\war3map."
	local filepath1 = "\" \"war3map."
	local filepath2 = "\""
	local cmd = filepath0..ext..filepath1..ext..filepath2
	wehack.runprocess2(cmd)
end

function fly_process_data(path,nolog,java)
	local cmdline
	if java then
		cmdline = "java -jar fly\\fly-1.0-SNAPSHOT.jar"
	else
		cmdline = "fly\\flycore.exe"		
	end
	if path == nil then
		cmdline = cmdline.." clean"
	else
		cmdline = cmdline.." "..path
	end
	if nolog then
		cmdline = cmdline.." nolog"
	end
	wehack.runprocess2(cmdline)
end

function fly_preprocess(mappath)
	if flyMenuEnabled.checked then
		--clean up
		fly_process_data(nil,not flyMenuExtLog.checked,flyMenuUseJava.checked)

		--export files
		--	units	--
		fly_export_scexp("w3u",mappath)
		--	items	--
		fly_export_scexp("w3t",mappath)
		--	abilities	--
		fly_export_scexp("w3a",mappath)
		--	destructables	--
		fly_export_scexp("w3b",mappath)
		--	strings	--
		fly_export_scexp("wts",mappath)
		--	code	--
		fly_export_scexp("j",mappath)

		--processing
		fly_process_data(mappath,not flyMenuLog.checked,flyMenuUseJava.checked)

		--importing wts
		--	fly_import_scexp("wts",mappath)

		--importing j
		fly_import_scexp("j",mappath)
	end
end